--RSS GTM BAYER V8 MFD
--Made by R_are_L https://twitter.com/R_are_L_

local R ={}
local G ={}
local TC = 0
local ABS = 0
local GEAR = 0
local SPEED = 0
local W_TEMP = 0
local BRAKET = 0
local lastfuel = 0
local FuelCons = 0
local OIL_TEMP = 0
local BRAKET_P = 0
local startFuel = 0
local BRAKEBIAS = 0
local TYRE_PRES = {}
local LAP_TIME_M = 0
local LAP_TIME_S = 0
local LAP_TIME_P = 0
local LAST_LAP_M = 0
local LAST_LAP_S = 0
local LAST_LAP_P = 0
local PitLimiter = 0
local BRAKEBIAS_P = 0
local CURRENT_FUEL = 0
local TYRE_PRES_LF = 0
local TYRE_PRES_RF = 0
local TYRE_PRES_LR = 0
local TYRE_PRES_RR = 0
local TYRE_PRES_LF_P = 0
local TYRE_PRES_RF_P = 0
local TYRE_PRES_LR_P = 0
local TYRE_PRES_RR_P = 0
local PitLimit = ac.getSim().pitsSpeedLimit
local TYRE_COLOR_LF = rgbm(0.24, 0.73, 0, 1)
local TYRE_COLOR_RF = rgbm(0.24, 0.73, 0, 1)
local TYRE_COLOR_LR = rgbm(0.24, 0.73, 0, 1)
local TYRE_COLOR_RR = rgbm(0.24, 0.73, 0, 1)

local function initialize()
	startFuel = (car.fuel)
	display.image{image = "assets/MFD/IND_TC.png",pos = vec2(5310,4070), size = vec2(424,424) }
	display.image{image = "assets/MFD/IND_ABSError.png",pos = vec2(5300,4570), size = vec2(488,352) }
	display.image{image = "assets/MFD/PitSpeed.png",pos = vec2(1670,1415), size = vec2(4952,936) }
	display.image{image = "assets/MFD/PitSpeedSign.png",pos = vec2(3410,2100), size = vec2(1352,1360) }
	display.image{image = "assets/MFD/IND_Engine.png",pos = vec2(5300,5010), size = vec2(464,336) }
	display.image{image = "assets/MFD/IND_Gearbox.png",pos = vec2(5320,5480), size = vec2(400,400) }
	display.image{image = "assets/MFD/IND_Fuel.png",pos = vec2(5940,3650), size = vec2(408,448)}
	display.image{image = "assets/MFD/IND_FuelAlarm.png",pos = vec2(150, 2710), size = vec2(2984, 2320)}
	display.image{image = "assets/MFD/IND_Flash.png",pos = vec2(5270,3650), size = vec2(528,328) }

	INITIALIZED = true

end

function update(dt)

	GEAR = string.format(car.gear)
	SPEED = string.format("%.0f",car.speedKmh)
	OIL_TEMP =  string.format("%.0f",car.oilTemperature)
	W_TEMP =  string.format("%.0f",car.waterTemperature)
	BRAKEBIAS = math.floor(string.format("%.1f", (car.brakeBias)*100))
	BRAKEBIAS_P = math.floor(string.format("%.1f", (car.brakeBias)*1000)-BRAKEBIAS*10)
	ABS = car.absMode
	TC = car.tractionControlMode
	CURRENT_FUEL = car.fuel
	BRAKET = math.floor(math.floor((BRAKEBIAS..BRAKEBIAS_P)*car.brake)/100)
	BRAKET_P = math.floor(((BRAKEBIAS..BRAKEBIAS_P)*car.brake)/10)-BRAKET*10
	LAP_TIME_M = string.format("%02d",math.floor(((car.lapTimeMs)/(1000*60))%60))
	LAP_TIME_S = string.format("%02d",math.floor(((car.lapTimeMs)/1000)%60))
	LAP_TIME_P = string.format("%.0f",math.floor(((car.lapTimeMs)/100)%10))
	LAST_LAP_M = string.format("%02d",math.floor(((car.previousLapTimeMs)/(1000*60))%60))
	LAST_LAP_S = string.format("%02d",math.floor(((car.previousLapTimeMs)/1000)%60))
	LAST_LAP_P = string.format("%.0f",math.floor(((car.previousLapTimeMs)/100)%10))
    PERF = string.format("%02d",car.performanceMeter)
    PERF_P = string.format("%02d",(math.floor(math.abs(car.performanceMeter*100)))-(math.floor(math.abs(car.performanceMeter))*100))
	TYRE_PRES_LF = math.floor(car.wheels[0].tyrePressure)
	TYRE_PRES_RF = math.floor(car.wheels[1].tyrePressure)
	TYRE_PRES_LR = math.floor(car.wheels[2].tyrePressure)
	TYRE_PRES_RR = math.floor(car.wheels[3].tyrePressure)
	TYRE_PRES_LF_P = string.format("%02d",(string.format("%.2f",car.wheels[0].tyrePressure)*100)-(TYRE_PRES_LF*100))
	TYRE_PRES_RF_P = string.format("%02d",(string.format("%.2f",car.wheels[1].tyrePressure)*100)-(TYRE_PRES_RF*100))
	TYRE_PRES_LR_P = string.format("%02d",(string.format("%.2f",car.wheels[2].tyrePressure)*100)-(TYRE_PRES_LR*100))
	TYRE_PRES_RR_P = string.format("%02d",(string.format("%.2f",car.wheels[3].tyrePressure)*100)-(TYRE_PRES_RR*100))

	for i=0,3 do
		TYRE_PRES[i] = (car.wheels[i].tyrePressure-26)/10
		G[i] = math.max(0,math.min(1,0.73*(1-TYRE_PRES[i])))
		R[i] = math.max(0.24,math.min(1,0.24+(0.7*TYRE_PRES[i])))
	end

	TYRE_COLOR_LF = rgbm(R[0], G[0], 0, 1)
	TYRE_COLOR_RF = rgbm(R[1], G[1], 0, 1)
	TYRE_COLOR_LR = rgbm(R[2], G[2], 0, 1)
	TYRE_COLOR_RR = rgbm(R[3], G[3], 0, 1)

	-----------------------------------------------------------------------------------

	if (car.gear) == -1 then
		GEAR = "R"
		elseif (car.gear) == 0 then
		GEAR = "N"
	end

	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end	

	if (car.lapTimeMs) <= 5000 then
		LAP_TIME_M = LAST_LAP_M
		LAP_TIME_S = LAST_LAP_S
		LAP_TIME_P = LAST_LAP_P
	end

	if (car.performanceMeter) >= 20 or (car.performanceMeter) <= -20 then
		PERF = " "
		PERF_P = " "
	end
	
	if (ac.getSim().isInMainMenu) or (car.isInPit) then
		startFuel = (car.fuel)
	end

	FuelCons = math.floor(string.format("%.1f",((startFuel)-(CURRENT_FUEL))))
	FuelCons_P = (string.format("%.1f",((startFuel)-(CURRENT_FUEL)))*10)-FuelCons*10

	-----------------------------------------------------------------------------------

	display.image{image = "assets/MFD/PAGE_1.png",pos = vec2(0,0), size = vec2(8192,8192) }
	display.image{image = "assets/MFD/RPM.png",pos = vec2(140,850), size = vec2(7932,1500) }
	display.rect{pos= vec2 (100+7965*(car.rpm/9000),1150) , size = vec2(7965,1200),color = rgbm(0.18, 0.18, 0.18, 1) }
	display.image{image = "assets/MFD/Overlay.png",pos = vec2(140,850), size = vec2(7932,1500) }
	display.rect{pos= vec2 (212, 2730) , size = vec2(1330,660),color = TYRE_COLOR_LF }
	display.rect{pos= vec2 (1730,2730) , size = vec2(1330,660),color = TYRE_COLOR_RF }
	display.rect{pos= vec2 (212, 3570) , size = vec2(1330,660),color = TYRE_COLOR_LR }
	display.rect{pos= vec2 (1730,3570) , size = vec2(1330,660),color = TYRE_COLOR_RR }
	display.text{pos= vec2 (3800,3720) , letter=vec2(800, 1715), text=GEAR, font="rss_gtm_2_modern", spacing =-1, color = rgbm(1, 1, 1, 1) }
	display.text{pos= vec2 (3650,5450) , letter=vec2(300, 600), text=SPEED, font="rss_gtm_2_modern", spacing =-10, color = rgbm(1, 1, 1, 1),width = 900, alignment = 0.5 }
	display.text{pos= vec2 (6730,4620) , letter=vec2(300, 600), text=OIL_TEMP, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 0.5 }
	display.text{pos= vec2 (6730,5450) , letter=vec2(300, 600), text=W_TEMP, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 0.5 }
	display.text{pos= vec2 (1440,5450) , letter=vec2(300, 600), text="1", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (2480,5450) , letter=vec2(300, 600), text=ABS, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (220,5450)  , letter=vec2(300, 600), text=TC, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 600, alignment = 0.5}
	display.text{pos= vec2 (1850,4590) , letter=vec2(300, 600), text=BRAKEBIAS, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (2330,4590) , letter=vec2(300, 600), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (2530,4590) , letter=vec2(300, 600), text=BRAKEBIAS_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (510,4590)  , letter=vec2(300, 600), text=BRAKET, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (720,4590)  , letter=vec2(300, 600), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (930,4590)  , letter=vec2(300, 600), text=BRAKET_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (3500,2850) , letter=vec2(300, 600), text=LAP_TIME_M, font="rss_gtm_2_modern", spacing =-10, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (4520,2850) , letter=vec2(300, 600), text=LAP_TIME_S, font="rss_gtm_2_modern", spacing =-10, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (5250,2850) , letter=vec2(300, 600), text=LAP_TIME_P, font="rss_gtm_2_modern", spacing =-10, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (4310,2850) , letter=vec2(300, 600), text=": .", font="rss_gtm_2_modern", spacing = 55, color = rgbm(1, 1, 1, 1)}
	display.text{pos= vec2 (6300,3660) , letter=vec2(300, 600), text=FuelCons, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (6730,3660) , letter=vec2(300, 600), text=FuelCons_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (6520,3660) , letter=vec2(300, 600), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (5910,2850) , letter=vec2(300, 600), text=PERF, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 1200, alignment = 1 }
	display.text{pos= vec2 (6930,2850) , letter=vec2(300, 600), text=PERF_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (6440,2850) , letter=vec2(300, 600), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (-60,2800)  , letter=vec2(280, 550), text=TYRE_PRES_LF, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (570,2800)  , letter=vec2(280, 550), text=TYRE_PRES_LF_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (120,2800)  , letter=vec2(280, 550), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (1440,2800) , letter=vec2(280, 550), text=TYRE_PRES_RF, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (2070,2800) , letter=vec2(280, 550), text=TYRE_PRES_RF_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (1620,2800) , letter=vec2(280, 550), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (-60,3650)  , letter=vec2(280, 550), text=TYRE_PRES_LR, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (570,3650)  , letter=vec2(280, 550), text=TYRE_PRES_LR_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (120,3650)  , letter=vec2(280, 550), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (1440,3650) , letter=vec2(280, 550), text=TYRE_PRES_RR, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (2070,3650) , letter=vec2(280, 550), text=TYRE_PRES_RR_P, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
	display.text{pos= vec2 (1620,3650) , letter=vec2(280, 550), text=".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }

	-----------------------------------------------------------------------------------

	if (car.performanceMeter) < 0 and (car.performanceMeter) >= -20 then
		display.text{pos= vec2 (5830,2800) , letter=vec2(500, 600), text="-", font="bosch", spacing =-20, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }
		if (car.performanceMeter) > -10 then
			display.text{pos= vec2 (5630,2850) , letter=vec2(300, 600), text="0", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1, 1, 1, 1),width = 1200, alignment = 1 }
		end
	end
	if (car.performanceMeter) >= 20 or (car.performanceMeter) <= -20 then
		display.text{pos= vec2 (6100,2800) , letter=vec2(500, 600), text="--", font="bosch", spacing =-200, color = rgbm(1, 1, 1, 1),width = 1200, alignment = 1 }
		display.text{pos= vec2 (7200,2800) , letter=vec2(500, 600), text="--", font="bosch", spacing =-200, color = rgbm(1, 1, 1, 1),width = 900, alignment = 1 }	
	end
 
	if car.tractionControlInAction then
		display.image{image = "assets/MFD/IND_TC.png",pos = vec2(5310,4070), size = vec2(424,424) }
	end

	if ABS == 0 then
		display.image{image = "assets/MFD/IND_ABSError.png",pos = vec2(5300,4570), size = vec2(488,352) }
	end

	if PitLimiter == 1 then
		display.image{image = "assets/MFD/PitSpeed.png",pos = vec2(1670,1415), size = vec2(4952,936) }
		display.image{image = "assets/MFD/PitSpeedSign.png",pos = vec2(3410,2100), size = vec2(1352,1360) }
		display.text{pos= vec2 (3640,2400) , letter=vec2(450, 940), text=PitLimit, font="rss_gtm_2_modern", spacing =-20, color = rgbm(0,0,0,1),width = 900, alignment = 0.5}
		display.text{pos= vec2 (4340,1840) , letter=vec2(240, 500), text= math.floor(car.speedKmh), font="rss_gtm_2_modern", spacing =-20, color = rgbm(1,1,1,1),width = 900, alignment = 1}
		display.text{pos= vec2 (4690,1840) , letter=vec2(240, 500), text=math.floor(car.speedKmh*10)-math.floor(car.speedKmh)*10, font="rss_gtm_2_modern", spacing =-20, color = rgbm(1,1,1,1),width = 900, alignment = 1}
		display.text{pos= vec2 (4520,1840) , letter=vec2(240, 500), text= ".", font="rss_gtm_2_modern", spacing =-20, color = rgbm(1,1,1,1),width = 900, alignment = 1}
	
	end

	if car.rpm < 100 then
		display.image{image = "assets/MFD/IND_Engine.png",pos = vec2(5300,5010), size = vec2(464,336) }
		display.image{image = "assets/MFD/IND_Gearbox.png",pos = vec2(5320,5480), size = vec2(400,400) }
	end

	if car.fuel < 10 then
		display.image{image = "assets/MFD/IND_Fuel.png",pos = vec2(5940,3650), size = vec2(408,448)}
		display.image{image = "assets/MFD/IND_FuelAlarm.png",pos = vec2(150, 2710), size = vec2(2984, 2320)}
	end

	if car.headlightsActive then
		display.image{image = "assets/MFD/IND_Flash.png",pos = vec2(5270,3650), size = vec2(528,328) }
	end

	display.image{image = "assets/MFD/mask.png",pos = vec2(0,0), size = vec2(8192,8192)}
	
	if not INITIALIZED then initialize() end

end