--RSS GTM LUX V8 LED
--Made by R_are_L https://twitter.com/R_are_L_

local LED = {}
local TimerPL = 0
local TimerRPM = 0
local PitLimiter = 0
local LED_ABS_0 = ac.findNodes("carRoot:" .. car.index):findMeshes("right_turnsignal_1"):ensureUniqueMaterials()
local LED_ABS_1 = ac.findNodes("carRoot:" .. car.index):findMeshes("left_turnsignal_1"):ensureUniqueMaterials()
local LED_TC_0 = ac.findNodes("carRoot:" .. car.index):findMeshes("RED_1"):ensureUniqueMaterials()
local LED_TC_1 = ac.findNodes("carRoot:" .. car.index):findMeshes("BLUE_1"):ensureUniqueMaterials()
local LED_FUEL = ac.findNodes("carRoot:" .. car.index):findMeshes("YELLOW_1"):ensureUniqueMaterials()

function update(dt)
	TimerPL = TimerPL + dt*3.2
    TimerRPM = TimerRPM + dt*15

	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end	

	for i = 0, 7 do
		LED[i] = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_"..i):ensureUniqueMaterials()
        if (car.rpm > 6000+(127.7*i)) then
            if i < 3 then
                LED[i]:setMaterialProperty("ksEmissive", vec3(0,125,0))
            elseif i < 4 then
                LED[i]:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
            elseif i < 6 then
                LED[i]:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
            else
                LED[i]:setMaterialProperty("ksEmissive", vec3(0,20,333))
            end
        end
        if car.rpm > 7150 then
            if (math.fmod(math.floor(TimerRPM), 2) == 1) then
                LED[i]:setMaterialProperty("ksEmissive", vec3(0,0,0))
            end
        end

        if PitLimiter == 1 then
            LED[i]:setMaterialProperty("ksEmissive", vec3(0,0,0))
            if (math.fmod(math.floor(TimerPL), 2) == 1) then
                LED[i]:setMaterialProperty("ksEmissive", vec3(0,20,333))
            end
        end
    end

    if car.absInAction then
        LED_ABS_0:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
        LED_ABS_1:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
    else
        LED_ABS_0:setMaterialProperty("ksEmissive", vec3(0,0,0))
        LED_ABS_1:setMaterialProperty("ksEmissive", vec3(0,0,0))
    end 

    if car.tractionControlInAction then
        LED_TC_0:setMaterialProperty("ksEmissive", vec3(0,20,333))
        LED_TC_1:setMaterialProperty("ksEmissive", vec3(0,20,333))
    else
        LED_TC_0:setMaterialProperty("ksEmissive", vec3(0,0,0))
        LED_TC_1:setMaterialProperty("ksEmissive", vec3(0,0,0))
    end

    if car.fuel <= 5 then
        if (math.fmod(math.floor(TimerPL*0.7), 2) == 1) then
            LED_FUEL:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
        else
            LED_FUEL:setMaterialProperty("ksEmissive", vec3(0,0,0))
        end
    end
end