--RSS GTM LUX V8 MFD
--Made by R_are_L https://twitter.com/R_are_L_

local GEAR = 0
local ABS = 0
local TC = 0
local RPM = 0
local SPEED = 0
local fuel = 0
local fuel_p = 0
local LAP_TIME_M = 0
local LAP_TIME_S = 0
local LAP_TIME_P = 0
local LAST_LAP_M = 0
local LAST_LAP_S = 0
local LAST_LAP_P = 0
local PERF = 0
local PERF_P = 0
local TYRE_PRES_LF = 0
local TYRE_PRES_RF = 0
local TYRE_PRES_LR = 0
local TYRE_PRES_RR = 0
local TYRE_PRES_LF_P = 0
local TYRE_PRES_RF_P = 0
local TYRE_PRES_LR_P = 0
local TYRE_PRES_RR_P = 0
local BBAL = 0
local BBAL_P = 0
local PitLimiter = 0
local TimerPOP = 0
local POP = 0
local W_TEMP =  0
local BVOL = 0
local BVOL_P = 0

local function initialize()

	
	display.image{image = "assets/MFD/P1.png",pos = vec2(108,-200), size = vec2(7974,7974)}
	display.image{image = "assets/MFD/RPM.png",pos = vec2(25,1010), size = vec2(8150,1350)}
	display.image{image = "assets/MFD/Overlay.png",pos = vec2(108,-200), size = vec2(7974,7974)}
	display.image{image = "assets/MFD/Popup_Speed.png",pos = vec2(108,2530), size = vec2(2528,2263)}
	display.image{image = "assets/MFD/Popup_ABS.png",pos = vec2(5520,2530), size = vec2(2528,2263)}
	display.image{image = "assets/MFD/Popup_TCS.png",pos = vec2(5520,2530), size = vec2(2528,2263)}
	display.image{image = "assets/MFD/Popup_RainLight.png",pos = vec2(2670, 4840), size = vec2(482,469)}
	display.image{image = "assets/MFD/Popup_HighBeam.png",pos = vec2(2075, 4840), size = vec2(482,469)}
	display.image{image = "assets/MFD/Popup_LowBeam.png",pos = vec2(1460, 4840), size = vec2(482,469)}
	display.image{image = "assets/MFD/Popup_PitLimiter.png",pos = vec2(3250, 5360), size = vec2(4092,505)}

	INITIALIZED = true

end

function update(dt)

	if TC ~= car.tractionControlMode then
		POP = 1
		TimerPOP = 0
	end

	if ABS ~= car.absMode then
		POP = 2
		TimerPOP = 0
	end

	if TimerPOP >= 1 then
		POP = 0
	else
		TimerPOP = TimerPOP + dt
	end

	---------------------------------------------------------------------------------------------------------------------------
	
	GEAR = string.format(car.gear)
	ABS = car.absMode
	TC = car.tractionControlMode
	RPM = string.format("%.f",car.rpm)
	SPEED = string.format("%.0f",car.speedKmh)
	fuel = math.floor(car.fuel)
	fuel_p = (math.floor(car.fuel*10))-(math.floor(car.fuel)*10)
	LAP_TIME_M = string.format("%01d",math.floor(((car.lapTimeMs)/(1000*60))%60))
	LAP_TIME_S = string.format("%02d",math.floor(((car.lapTimeMs)/1000)%60))
	LAP_TIME_P = string.format("%02d",math.floor(((car.lapTimeMs)/10)%100))
	LAST_LAP_M = string.format("%01d",math.floor(((car.previousLapTimeMs)/(1000*60))%60))
	LAST_LAP_S = string.format("%02d",math.floor(((car.previousLapTimeMs)/1000)%60))
	LAST_LAP_P = string.format("%02d",math.floor(((car.previousLapTimeMs)/10)%100))
	PERF = string.format("%02d",math.abs(car.performanceMeter))
    PERF_P = string.format("%02d",(math.floor(math.abs(car.performanceMeter*100)))-(math.floor(math.abs(car.performanceMeter))*100))
	TYRE_PRES_LF = math.floor(car.wheels[0].tyrePressure)
	TYRE_PRES_RF = math.floor(car.wheels[1].tyrePressure)
	TYRE_PRES_LR = math.floor(car.wheels[2].tyrePressure)
	TYRE_PRES_RR = math.floor(car.wheels[3].tyrePressure)
	TYRE_PRES_LF_P = string.format(math.floor((car.wheels[0].tyrePressure*10)-TYRE_PRES_LF*10))
	TYRE_PRES_RF_P = string.format(math.floor((car.wheels[1].tyrePressure*10)-TYRE_PRES_RF*10))
	TYRE_PRES_LR_P = string.format(math.floor((car.wheels[2].tyrePressure*10)-TYRE_PRES_LR*10))
	TYRE_PRES_RR_P = string.format(math.floor((car.wheels[3].tyrePressure*10)-TYRE_PRES_RR*10))
	BBAL = math.floor(string.format("%.2f",(car.brakeBias*100)))
	BBAL_P = math.floor(math.max((string.format("%.2f",(car.brakeBias*10))*100)-BBAL*10,0))
	W_TEMP =  string.format("%.0f",car.waterTemperature)
	BVOL = math.floor(car.batteryVoltage)
	BVOL_P = (math.floor(car.batteryVoltage*10))-(math.floor(car.batteryVoltage)*10)

	---------------------------------------------------------------------------------------------------------------------------
	
	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = true
	else
		PitLimiter = false
	end

	if (car.gear) == -1 then
		GEAR = "R"
		elseif (car.gear) == 0 then
		GEAR = "N"
	end

	if (car.lapTimeMs) <= 10000 then
		LAP_TIME_M = LAST_LAP_M
		LAP_TIME_S = LAST_LAP_S
		LAP_TIME_P = LAST_LAP_P
	end
	
	if (car.performanceMeter) >= 20 or (car.performanceMeter) <= -20 then
		PERF = "--"
		PERF_P = "--"
	end

	if car.performanceMeter < 0 and car.performanceMeter > -20 then
		PERF = "-"..PERF
	else
		PERF = PERF
	end

	---------------------------------------------------------------------------------------------------------------------------
	
	display.rect{pos=vec2(0,0), size=vec2(8192,8192), color=rgbm(0.039,0.051,0.075,1)}
	display.image{image = "assets/MFD/P1.png",pos = vec2(108,-200), size = vec2(7974,7974)}
	display.image{image = "assets/MFD/RPM.png",pos = vec2(25,1010), size = vec2(8150,1350)}
	display.rect{pos = vec2(108+car.rpm*0.993,1010), size = vec2(8150,1350), color=rgbm(0.039,0.051,0.075,1)}
	display.image{image = "assets/MFD/Overlay.png",pos = vec2(108,-200), size = vec2(7974,7974)}
	display.text{pos=vec2(3700,3950), letter=vec2(760, 1600), text=GEAR, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1170,2580), letter=vec2(270, 600), text=SPEED, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(6190,2580), letter=vec2(270, 600), text=fuel, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(7100,2580), letter=vec2(270, 600), text=fuel_p, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(6920,2625), letter=vec2(270, 600), text=".", font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1170,3190), letter=vec2(270, 600), text=W_TEMP, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(6190,3190), letter=vec2(270, 600), text=BBAL, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(7100,3190), letter=vec2(270, 600), text=BBAL_P, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(6920,3225), letter=vec2(270, 600), text=".", font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(2740,2580), letter=vec2(270, 600), text=LAP_TIME_M, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(3380,2580), letter=vec2(270, 600), text=LAP_TIME_S, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(4040,2580), letter=vec2(270, 600), text=LAP_TIME_P, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(3470,2625), letter=vec2(270, 600), text=": .", font="rss_gtm_5_thin", spacing=55, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(3180,3190), letter=vec2(270, 600), text=PERF, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=810, alignment=1}
	display.text{pos=vec2(4130,3190), letter=vec2(270, 600), text=PERF_P, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(3930,3225), letter=vec2(270, 600), text=".", font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1440, 3825), letter=vec2(250, 530), text=TYRE_PRES_LF, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=750, alignment=1}
	display.text{pos=vec2(2320, 3825), letter=vec2(250, 530), text=TYRE_PRES_LF_P, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(2135, 3850), letter=vec2(250, 530), text=".", font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1440, 4350), letter=vec2(250, 530), text=TYRE_PRES_LR, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=750, alignment=1}
	display.text{pos=vec2(2320, 4350), letter=vec2(250, 530), text=TYRE_PRES_LR_P, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(2135, 4375), letter=vec2(250, 530), text=".", font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(5520, 3825), letter=vec2(250, 530), text=TYRE_PRES_LF, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=750, alignment=1}
	display.text{pos=vec2(6400, 3825), letter=vec2(250, 530), text=TYRE_PRES_LF_P, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(6215, 3850), letter=vec2(250, 530), text=".", font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(5520, 4350), letter=vec2(250, 530), text=TYRE_PRES_LR, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=750, alignment=1}
	display.text{pos=vec2(6400, 4350), letter=vec2(250, 530), text=TYRE_PRES_LR_P, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(6215, 4375), letter=vec2(250, 530), text=".", font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1400, 5450), letter=vec2(240, 530), text=BVOL, font="rss_gtm_5_thin", spacing=-22, color=rgbm(1, 1, 1, 1), width=720, alignment=1}
	display.text{pos=vec2(2220, 5450), letter=vec2(250, 530), text=BVOL_P, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(2030, 5475), letter=vec2(250, 530), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(5090,5010), letter=vec2(150, 300), text=TC, font="rss_gtm_5_thin", spacing=-10, color=rgbm(1, 1, 1, 1), width=300, alignment=0.5}
	display.text{pos=vec2(5760,5010), letter=vec2(150, 300), text="2 2 1", font="rss_gtm_5_thin", spacing=156, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(7490,5010), letter=vec2(150, 300), text=ABS, font="rss_gtm_5_thin", spacing=-10, color=rgbm(1, 1, 1, 1), width=300, alignment=0.5}
	
	---------------------------------------------------------------------------------------------------------------------------

	if car.extraA then
		display.image{image = "assets/MFD/Popup_RainLight.png",pos = vec2(2670, 4840), size = vec2(482,469)}
	end

	if car.headlightsActive then
		display.image{image = "assets/MFD/Popup_HighBeam.png",pos = vec2(2075, 4840), size = vec2(482,469)}
		display.image{image = "assets/MFD/Popup_LowBeam.png",pos = vec2(1460, 4840), size = vec2(482,469)}
	end
	
	if PitLimiter then
		display.image{image = "assets/MFD/Popup_PitLimiter.png",pos = vec2(3250, 5360), size = vec2(4092,505)}
		display.image{image = "assets/MFD/Popup_Speed.png",pos = vec2(108,2530), size = vec2(2528,2263)}
		display.text{pos=vec2(110, 3210), letter=vec2(840, 1840), text=SPEED, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=2520, alignment=0.5}
	end
	
	if POP == 1 then
		display.image{image = "assets/MFD/Popup_TCS.png",pos = vec2(5520,2530), size = vec2(2528,2263)}
		display.text{pos=vec2(5500, 3210), letter=vec2(840, 1840), text=TC, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=2520, alignment=0.5}
	end

	if POP == 2 then
		display.image{image = "assets/MFD/Popup_ABS.png",pos = vec2(5520,2530), size = vec2(2528,2263)}
		display.text{pos=vec2(5500, 3210), letter=vec2(840, 1840), text=ABS, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=2520, alignment=0.5}
	end
	
	display.text{pos=vec2(3740,5480), letter=vec2(180, 420), text=RPM, font="rss_gtm_5_thin", spacing=-15, color=rgbm(1, 1, 1, 1), width=720, alignment=0.5}
	
end